// 402_3  1

#include <cstdio>
#include <algorithm>
#include <iostream>
#include <memory>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

struct pt{
	int x,y,z;
};
pt p1[6],p2[6];
pt v1[3],v2[3];

pt norm(pt a,pt b,pt c)
{
	pt n;
	int dx1=a.x-b.x,dy1=a.y-b.y,dz1=a.z-b.z,
		dx2=a.x-c.x,dy2=a.y-c.y,dz2=a.z-c.z;
	n.x=dy1*dz2-dz1*dy2;
	n.y=dx1*dz2-dx2*dz1;
	n.z=dx1*dy2-dy1*dx2;
	return n;
}

int calc(pt a,pt b,pt c)
{
	pt n=norm(a,b,c);
	int d=-(n.x*a.x+n.y*a.y+n.z*a.z);
	int i=0,ans=1;
	while(p1[i].x*n.x+p1[i].y*n.y+p1[i].z*n.z+d == 0 ) i++;
	int z=p1[i].x*n.x+p1[i].y*n.y+p1[i].z*n.z+d;
	for(;i<6;i++){
		if(z*(p1[i].x*n.x+p1[i].y*n.y+p1[i].z*n.z+d)<0 ){ans=0;return 0;}
	}
	z*=-1;
	for(i=0;i<6;i++){
		if(z*(p2[i].x*n.x+p2[i].y*n.y+p2[i].z*n.z+d)<0 ){ans=0;return 0;}
	}
	return ans;
}

void solve()
{
	scanf("%d%d%d",&p1[0].x,&p1[0].y,&p1[0].z);
	scanf("%d%d%d",&v1[0].x,&v1[0].y,&v1[0].z);
	scanf("%d%d%d",&v1[1].x,&v1[1].y,&v1[1].z);
	scanf("%d%d%d",&v1[2].x,&v1[2].y,&v1[2].z);

	scanf("%d%d%d",&p2[0].x,&p2[0].y,&p2[0].z);
	scanf("%d%d%d",&v2[0].x,&v2[0].y,&v2[0].z);
	scanf("%d%d%d",&v2[1].x,&v2[1].y,&v2[1].z);
	scanf("%d%d%d",&v2[2].x,&v2[2].y,&v2[2].z);
	
	p1[1].x=p1[0].x+v1[0].x;   p1[1].y=p1[0].y+v1[0].y; p1[1].z=p1[0].z+v1[0].z;
	p1[2].x=p1[0].x+v1[1].x;   p1[2].y=p1[0].y+v1[1].y; p1[2].z=p1[0].z+v1[1].z;
	p1[3].x=p1[0].x+v1[2].x;   p1[3].y=p1[0].y+v1[2].y; p1[3].z=p1[0].z+v1[2].z;

	p1[4].x=p1[0].x+v1[0].x+v1[1].x;   p1[4].y=p1[0].y+v1[0].y+v1[1].y; p1[4].z=p1[0].z+v1[0].z+v1[1].z;
	p1[5].x=p1[0].x+v1[0].x+v1[2].x;   p1[5].y=p1[0].y+v1[0].y+v1[2].y; p1[5].z=p1[0].z+v1[0].z+v1[2].z;
	p1[6].x=p1[0].x+v1[1].x+v1[2].x;   p1[6].y=p1[0].y+v1[1].y+v1[2].y; p1[6].z=p1[0].z+v1[1].z+v1[2].z;

	p1[7].x=p1[0].x+v1[0].x+v1[1].x+v1[2].x;   p1[7].y=p1[0].y+v1[0].y+v1[1].y+v1[2].y; p1[7].z=p1[0].z+v1[0].z+v1[1].z+v1[2].z;

	p2[1].x=p2[0].x+v2[0].x;   p2[1].y=p2[0].y+v2[0].y; p2[1].z=p2[0].z+v2[0].z;
	p2[2].x=p2[0].x+v2[1].x;   p2[2].y=p2[0].y+v2[1].y; p2[2].z=p2[0].z+v2[1].z;
	p2[3].x=p2[0].x+v2[2].x;   p2[3].y=p2[0].y+v2[2].y; p2[3].z=p2[0].z+v2[2].z;

	p2[4].x=p2[0].x+v2[0].x+v2[1].x;   p2[4].y=p2[0].y+v2[0].y+v2[1].y; p2[4].z=p2[0].z+v2[0].z+v2[1].z;
	p2[5].x=p2[0].x+v2[0].x+v2[2].x;   p2[5].y=p2[0].y+v2[0].y+v2[2].y; p2[5].z=p2[0].z+v2[0].z+v2[2].z;
	p2[6].x=p2[0].x+v2[1].x+v2[2].x;   p2[6].y=p2[0].y+v2[1].y+v2[2].y; p2[6].z=p2[0].z+v2[1].z+v2[2].z;

	p2[7].x=p2[0].x+v2[0].x+v2[1].x+v2[2].x;   p2[7].y=p2[0].y+v2[0].y+v2[1].y+v2[2].y; p2[7].z=p2[0].z+v2[0].z+v2[1].z+v2[2].z;

	
	

	int f1=0;
	f1=max(f1,calc(p1[0],p1[1],p1[2]));
	f1=max(f1,calc(p1[0],p1[1],p1[3]));
	f1=max(f1,calc(p1[0],p1[2],p1[3]));
	f1=max(f1,calc(p1[7],p1[4],p1[5]));
	f1=max(f1,calc(p1[7],p1[4],p1[6]));
	f1=max(f1,calc(p1[7],p1[5],p1[6]));

	f1=max(f1,calc(p2[0],p2[1],p2[2]));
	f1=max(f1,calc(p2[0],p2[1],p2[3]));
	f1=max(f1,calc(p2[0],p2[2],p2[3]));
	f1=max(f1,calc(p2[7],p2[4],p2[5]));
	f1=max(f1,calc(p2[7],p2[4],p2[6]));
	f1=max(f1,calc(p2[7],p2[5],p2[6]));

	
	if(!f1)printf("YES\n");
	else printf("NO\n");
}

int main()
{
	freopen("crossing.in","r",stdin);
	int t;
	scanf("%d",&t);
	while(t--)
		solve();
}

//void solve()
//{
//	/*
//	long long k;
//	int p1, p2, p3;
//	cin>>k>>p1>>p2>>p3;
//	long double t1 = (long double)p1/100;
//	long double t2 = (long double)p2/100;
//	long double t3 = (long double)p3/100;
//	long double a = (2*t2-1)*k/(2*t1-2*t2+t3-0.5);
//	long long q = floor(a+0.5+1e-9);
//	if(q==k)
//		--q;
//	cout<<q<<'\n';
//*/
//}